SCREEN 13: CLS
ON ERROR GOTO ErrHandle
LOCATE 15, 1: PRINT "H: set cursor Hotspot"
PRINT "S: Save cursor"
PRINT "L: Load cursor"
PRINT "C: Clear cursor"
PRINT "+/-: Change color"
PRINT "    (0:Black, 1:White, 2:Background)"
PRINT "SpaceBar: Fill in pixel"
PRINT "Arrow keys: Move box"
A$ = "": COL = 1
CONST True = -1, False = 0
LINE (221, 64)-(240, 83), 40, B
ClearScreen: LINE (223, 66)-(238, 81), 32, BF
FinalLoad:
LINE (X * 6 + 2, Y * 6 + 6)-(X * 6 + 8, Y * 6 + 12), 0, B
   FOR Y = 0 TO 15
      FOR X = 0 TO 15
         LINE (X * 6 + 3, Y * 6 + 7)-(X * 6 + 7, Y * 6 + 11), POINT(223 + X, 66 + Y), BF
      NEXT X
   NEXT Y
LINE (1, 5)-(99, 103), 40, B
IF Inited = False THEN X = 8: Y = 8 ELSE Inited = True
A$ = "": GOSUB ColorChange: GOTO l2
ReLoop: A$ = INKEY$: IF A$ = "" GOTO ReLoop
l2: A$ = UCASE$(A$)
   IF A$ = "+" OR A$ = "=" THEN COL = COL + 1: GOSUB ColorChange: GOTO ReLoop
   IF A$ = "-" OR A$ = "_" THEN COL = COL - 1: GOSUB ColorChange: GOTO ReLoop
   IF A$ = CHR$(32) THEN GOSUB DisplayPicture: GOTO ReLoop
   IF A$ = "S" THEN GOSUB Saver: GOTO ReLoop
   IF A$ = "L" THEN GOTO Loader
   IF A$ = "C" THEN GOTO ClearScreen
   IF A$ = "H" THEN GOTO HotSpot
   LINE (X * 6 + 2, Y * 6 + 6)-(X * 6 + 8, Y * 6 + 12), 0, B
   IF A$ = CHR$(0) + CHR$(&H48) THEN Y = Y - 1
   IF A$ = CHR$(0) + CHR$(&H50) THEN Y = Y + 1
   IF A$ = CHR$(0) + CHR$(&H4B) THEN X = X - 1
   IF A$ = CHR$(0) + CHR$(&H4D) THEN X = X + 1
   IF Y < 0 THEN Y = 15 ELSE IF Y > 15 THEN Y = 0
   IF X < 0 THEN X = 15 ELSE IF X > 15 THEN X = 0
   LINE (X * 6 + 2, Y * 6 + 6)-(X * 6 + 8, Y * 6 + 12), 47, B
GOTO ReLoop
END
DisplayPicture:
   IF COL = 1 THEN CL = 15 ELSE IF COL = 2 THEN CL = 32 ELSE CL = 0
   LINE (X * 6 + 3, Y * 6 + 7)-(X * 6 + 7, Y * 6 + 11), CL, BF
   PSET (X + 223, Y + 66), CL
   RETURN
ColorChange:
   IF COL > 2 THEN COL = 0 ELSE IF COL < 0 THEN COL = 2
   LOCATE 8, 30: PRINT "Color:"; LTRIM$(STR$(COL))
   RETURN
Saver:
   Csr$ = "": Csr2$ = "": F = 0: K = 0
   ST$ = CHR$(XSPT * 16 + YSPT)
   LOCATE 1, 31: PRINT "Saving  "
   LOCATE 2, 30: PRINT "Filename:"
   LOCATE 3, 30: PRINT SPACE$(10)
   LOCATE 3, 30: INPUT "", R$
   FOR Y = 0 TO 15
      FOR X = 0 TO 15
         IF POINT(223 + X, 66 + Y) = 32 THEN F = F + 2 ^ (15 - X)
         IF POINT(223 + X, 66 + Y) = 15 THEN K = K + 2 ^ (15 - X)
      NEXT X
      IF F > 32767 THEN F = F - 65536
      IF K > 32767 THEN K = K - 65536
      Csr$ = Csr$ + MKI$(F)
      Csr2$ = Csr2$ + MKI$(K)
      F = 0: K = 0
   NEXT Y
    OPEN R$ + ".CSR" FOR BINARY AS #1
    PUT #1, , ST$: PUT #1, , Csr$: PUT #1, , Csr2$: CLOSE #1
GOTO ReLoop
Loader:
   LOCATE 1, 31: PRINT "Loading "
   LOCATE 2, 30: PRINT "Filename:"
   LOCATE 3, 30: PRINT SPACE$(10)
   LOCATE 3, 30: INPUT "", R$
   OPEN R$ + ".CSR" FOR BINARY AS #1
   H$ = " ": GET #1, , H$
   XSPT = INT(ASC(H$) / 16): YSPT = ASC(H$) - XSPT * 16
   GOSUB HS
      FOR Y = 0 TO 15
         FOR N = 0 TO 1
           GET #1, , H$: LK = ASC(H$)
            FOR X = 7 TO 0 STEP -1
               IF LK >= 2 ^ X THEN PSET (238 - X - N * 8, 66 + Y), 32: LK = LK - 2 ^ X ELSE PSET (238 - X - N * 8, 66 + Y), 0
            NEXT X
         NEXT N
      NEXT Y
      FOR Y = 0 TO 15
         FOR N = 0 TO 1
           GET #1, , H$: LK = ASC(H$)
            FOR X = 7 TO 0 STEP -1
               IF LK >= 2 ^ X THEN PSET (238 - X - N * 8, 66 + Y), 15: LK = LK - 2 ^ X
            NEXT X
         NEXT N
      NEXT Y
   CLOSE #1
   GOTO FinalLoad
ErrHandle:
LOCATE 1, 31: PRINT " Error! "
LINE (X * 6 + 2, Y * 6 + 6)-(X * 6 + 8, Y * 6 + 12), 0, B
A$ = ""
GOTO ReLoop
HS:
   LOCATE 1, 18: PRINT "HotSpot"
   LOCATE 2, 17: PRINT "X:"; LTRIM$(STR$(XSPT)); "   Y:"; LTRIM$(STR$(YSPT))
RETURN
HotSpot:
   LOCATE 1, 31: PRINT "Hotspot:"
   LOCATE 2, 30: PRINT "         "
   LOCATE 3, 30: PRINT "        "
   LOCATE 2, 31: INPUT "X:", XSPT
   LOCATE 3, 31: INPUT "Y:", YSPT
GOSUB HS
GOTO ReLoop

